/***************************************************************************
                          data.c
  description: data
                             -------------------
    begin                : Fri March 30 2001
    date                 : 13/07/2010
    copyright            : (C) 2001 Interlinux Ltd
    email                : dbrasher@interlinux.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <SDL/SDL_image.h>
#include "structs.h"
#include "data.h"

SDL_Surface *LoadImage(char *datafile, int transparent)
{
	SDL_Surface *image, *surface;

	image = IMG_Load(datafile);
	if ( image == NULL )
	{
		fprintf(stderr, "Couldn't load image %s: %s\n",
					datafile, IMG_GetError());
		return(NULL);
	}
	if ( transparent )
	{
		//Assumiing 8-bit BMP image
		SDL_SetColorKey(image, (SDL_SRCCOLORKEY|SDL_RLEACCEL),
						*(Uint8 *)image->pixels);
	}
	surface = SDL_DisplayFormat(image);
	SDL_FreeSurface(image);
	return(surface);
}

SDL_Surface *LoadImage2(char *filename, int transparent)
{
	char buf[PATH_MAX + 4];

#ifdef __LINUX__
	if (strncpy(buf, DSI_DATA_DIR, PATH_MAX) == NULL)
#else
	//if (strncpy(buf, DSI_CUR, PATH_MAX) == NULL)
#endif
		return NULL;
	if (strncat(buf, DIR_SEP, PATH_MAX - strlen(buf)) == NULL)
		return NULL;
	if (strncat(buf, filename, PATH_MAX - strlen(buf)) == NULL)
		return NULL;
	return LoadImage(buf, 1);
}
