/***************************************************************************
                          sound.c
  description: data
                             -------------------
    begin                : Fri March 30 2001, then part of data.c
    date                 : 21/07/2010
    copyright            : (C) 2001 Interlinux Ltd
    email                : dbrasher@interlinux.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sound.h"

char *music_file;
int music_decoder;

Mix_Music *music;
Mix_Chunk *sounds[NUM_WAVES];


/* Load sounds */
int sound_init(void)
{
	int i;

	// Clear the data
	for (i = 0; i < NUM_WAVES; ++i)
		Mix_FreeChunk(sounds[i]);
	music = NULL;

	if (music_decoder == MPLAY_FILE)
		music = Mix_LoadMUS(music_file);
	else if (music_decoder == MPLAY_MOD)
		music = Mix_LoadMUS(DATAFILE("music.it"));
	else if (music_decoder == MPLAY_WAV)
		sounds[MUSIC_WAV] = Mix_LoadWAV(DATAFILE("music.wav"));
	sounds[SHOT_WAV] = Mix_LoadWAV(DATAFILE("shot.wav"));
	sounds[EXPLODE_WAV] = Mix_LoadWAV(DATAFILE("explode.wav"));
	return 1;
}

void sound_free(void)
{
	int i;

	//Free sounds
	if (music != NULL)
		Mix_FreeMusic(music);

	for ( i=0; i<NUM_WAVES; ++i )
	{
		if (sounds[i])
			Mix_FreeChunk(sounds[i]);
		sounds[i] = NULL;
	}
}
